# MALHasher

`malhasher` is a custom Python package that provides SHA256 and SHA1 hashing functions, and a feature to match generated hash values against a dataset of hash values stored in a CSV file within the package.

## Installation

To install the package, run the following command:

```sh
pip install malhasher
```

## Features

- **SHA256 Hashing**: Generate SHA256 hash values for strings and files.
- **SHA1 Hashing**: Generate SHA1 hash values for strings and files.
- **Hash Matching**: Match generated hash values against a precomputed dataset of hash values stored in a CSV file.


### SHA256 Hashing
Generate SHA256 hash for a given string.
Generate SHA256 hash for a file.

### SHA1 Hashing

Generate SHA1 hash for a given string.
Generate SHA1 hash for a file.

### Hash Matching
Load a dataset of hash values from a CSV file.
Match generated hash values against the dataset of hash values.

## Importing the Package
```sh
from malhasher import sha256, sha1, sha256_file, sha1_file, load_hash_dataset_from_csv, load_hash_dataset_from_package, match_hash
```

## Generate SHA256 Hash for a File
```sh
from malhasher import sha256_file

file_path = "path/to/your/file"
file_hash_value = sha256_file(file_path)
print(f"SHA256 file: {file_hash_value}")
```
### Generate SHA256 Hash for a String

```sh
from malhasher import sha256

data = b"example data"
hash_value = sha256(data)
print(f"SHA256: {hash_value}")
```
## Generate SHA1 Hash for a File

```sh
from malhasher import sha1_file

file_path = "path/to/your/file"
file_hash_value = sha1_file(file_path)
print(f"SHA1 file: {file_hash_value}")
```

### Generate SHA1 Hash for a String

```sh
from malhasher import sha1

data = b"example data"
hash_value = sha1(data)
print(f"SHA1: {hash_value}")

```
